
//************************************************ начальные установки и пременные ***********************************************
int old_open = 0;                                 // Значение датчика открытых ворот
int old_close = 0;                                // Значение датчика закрытых ворот
int old_gatesensor = 0;                           // Значение датчика пересечения проема
int old_movement = 0;                             // Датчик движения
int old_buttonopen = 0;                           // Кнопка либо контакный датчик
int old_buttonclose = 0;                          // Кнопка либо контакный датчик
char buf[80];                                     // Буфер приема символов екость 80 едениц
//************************************************ Начальные установки параметров микроконтроллера ************************************
void setup()
{
  digitalWrite(2, HIGH);                              // Датчик открытых ворот определим входной уровень для настройки
  digitalWrite(3, HIGH);                              // Датчик закрытых ворот
  digitalWrite(4, HIGH);                              // Датчик пересечения проема ворот
  digitalWrite(5, HIGH);                              // Датчик движения во дворе
  digitalWrite(6, HIGH);                              // Кнопка открыть ворота
  digitalWrite(7, HIGH);                              // Кнопка закрыть ворота
  pinMode(8, OUTPUT);                                 // Реле открыть створу
  pinMode(9, OUTPUT);                                 // Реле закрыть створу
  digitalWrite (8, HIGH);                             // Выключим реле "Открыть"
  digitalWrite (9, HIGH);                             // Выключим реле "Закрыть"
  old_open = digitalRead(2);                          // Считаем начальные значения с контакных датчиков и кнопок для инициализации (датчик открыто)
  old_close = digitalRead(3);                         // Датчик Закрыто
  old_gatesensor = digitalRead(4);                    // Датчик пересечение проема
  old_movement = digitalRead(5);                      // Датчик движения (опция для включения света)
  old_buttonopen = digitalRead(6);                    // Кнопка открыть ворота
  old_buttonclose = digitalRead(7);                   // Кнопка закрыть ворота
  Serial.begin(9600);                                 // Установим настройки порта USART
}
//************************************************ Цикл опроса датчиков и управление реле ***********************************************
void loop()
  {
  //***********************************************   GATES OPEN SENSOR  ****************************************************************
  int current_open = digitalRead(2);                  // Определяем текущее значение датчика "Открыто"
  if (current_open != (int)old_open)                  // Если текущее значение изменилось на противоположное то:
  {
    old_open = (int)current_open;                     // Обновляем значение датчика
    sprintf(buf, "GET /objects/?object=GateOpen&op=m&m=statusChanged&status=%i HTTP/1.0", (int)current_open);  // заполняем буфер
    Serial.println(buf);                              // Передаем новое значение контакного датчика GateOpen на сервер
    if (old_open == LOW)                              // Если "сработал" датчик крайнего положения (открыто) то
    {
      digitalWrite (8, HIGH);                         // Отключаем реле "открыть" (останавливаем привод)

    }
  }

  //**********************************************   GATES CLOSE SENSOR  **********************************************************************
  int current_close = digitalRead(3);                 // Определяем текущее значение датчика "Закрыто"
    if (current_close != (int)old_close)              // Если текущее значение изменилось на противоположное то
  {
    old_close = (int)current_close;                   // Обновляем значение датчика
    sprintf(buf, "GET /objects/?object=GateClose&op=m&m=statusChanged&status=%i HTTP/1.0", (int)current_close);  // заполняем буфер
    Serial.println(buf);                              // Передаем новое значение контакного датчика SensorClose на сервер
    if (old_close == LOW)                             // Если сработал датчик крайнего положения (закрыто) то
    {
      digitalWrite (9, HIGH);                         // Отключаем реле "закрыть" (останавливаем привод)
    }
  }

  //GATE SENSOR
  int current_gatesensor = digitalRead(4);            // Определяем текущее значение датчика "Открыто"
  if (current_gatesensor != (int)old_gatesensor)      // Если зафиксировано изменение текущего значения датчика пресечения проема ворот
  {
      old_gatesensor = (int)current_gatesensor;       // Обновляем значение датчика
      sprintf(buf, "GET /objects/?object=GateSensor&op=m&m=statusChanged&status=%i HTTP/1.0", (int)current_gatesensor);  // передаем значение на сервер
      Serial.println(buf);                            // Передаем новое значение контакного датчика GateSensor на сервер
    if (current_gatesensor == LOW)                    // Если сработал датчик пересечения проема то останавливаем привод сразу
    {
      digitalWrite (9, HIGH);                         // Отключаем реле "закрыть"
      delay (2000);                                   // ждем 2 секунды для проверки
    }
    else
    {
      current_gatesensor = digitalRead(4);            // Проверим состояние датчика пересечения проема еще раз на наличие препятствия
      if (current_gatesensor == LOW)
      {
        
        delay (6000);                                 // Останавливаем привод на 6 сек
        current_gatesensor = digitalRead(4);          // Проверим состояние датчика пересечения проема еще раз на наличие препятствия
        if (current_gatesensor == HIGH)               // если "препятствие отсутсвует" то запускаем двигатель и закрываем створу
        {
          digitalWrite (9, LOW);                      // Пускаем привод закрыть ворота
        }
        else                                          // иначе
        {
          digitalWrite (9, HIGH);                     // Ждем, пока не освободится проем, чтобы затем, закрыть ворота
        }
      }
      }
      }

      //********************************************** MOVEMENT SENSOR **************************************************************
      int current_movement = digitalRead(5);          // Определяем текущее значение датчика "Движение"
      if (current_movement != (int)old_movement)
      {
        old_movement = (int)current_movement;         // Обновляем значение датчика
        sprintf(buf, "GET /objects/?object=SesorMove&op=m&m=statusChanged&status=%i HTTP/1.0", (int)current_movement);  // передаем значение на сервер
        Serial.println(buf);                          // Передаем новое значение контакного датчика MoveSensor на сервер
      }

      //********************************************** BUTTON OPEN *********************************************************************
      int current_buttonopen = digitalRead(6);        // Прочитаем текущее состояние кнопки "Открыть"
      if (current_buttonopen == LOW)                  // Если подтверждено нажатие кнопки
      {
        delay(1000);                                  // Водим временную задержку для подтверждения нажатия на кнопку (более 1 сек)
        current_buttonopen = digitalRead(6);          // Подтверждаем что кнопка нажата
        if (current_buttonopen == LOW)                // Длительное нажатие кнопки "Открыть ворота"
        {
          if ((int)current_open == HIGH) 	      // Если ворота открыты не полностью или не полностью закрыты то
          {
            digitalWrite (8, LOW);                    // включаем привод на открытие
          }
          else
          {
            digitalWrite (8, HIGH);                   // Реле "открыть" не включаем пропуск строки
          }
        }
      }

      //********************************************** BUTTON CLOSE ************************************************************************
      int current_buttonclose = digitalRead(7);       // Прочитаем текущее состояние кнопки "Закрыть"
      if (current_buttonclose == LOW)                 // Если текущее сосояние отлично от ранее записаннного то:
      {
        delay(1000);                                  // Водим паузу для подтверждения длительного нажатия (более 1 сек) на кнопку
        current_buttonclose = digitalRead(7);         // Подтверждаем что кнопка нажата
        if (current_buttonclose == LOW)               // Длительное нажатие кнопки "Закрыть ворота"
        {  
          if ((int)current_close == HIGH)   	// Если ворота открыты или закрыты не полностью то
          {
            digitalWrite (9, LOW);                  // включаем привод на закрытие при условии,  что ворота не закрыты или открыты не полностью
          }
          else                                      // иначе
          {
            digitalWrite (9, HIGH);                 // Реле "закрыть" не включаем пропуск строки
          }
        }
      }

      //********************************************** Проверим команды на управление от сервера **************************************************
      String content = "";
      char character;
      while (Serial.available())
      {
        character = Serial. read();
        content. concat (character);
        delay (2);
      }
      if (content.length() > 0) {
        if (content.equals("81")) {                 // Если команда от МД "81" включаем реле "Открыть ворота"
          digitalWrite (8, LOW);
        }
        if (content.equals("91")) {                 // Если команда "91" включаем реле "Закрыть ворота"
          digitalWrite (9, LOW);
        }
        if (content.equals("00")) {                 // Если команда "00" выключаем все реле (команда стоп)
          digitalWrite (8, HIGH);
          digitalWrite (9, HIGH);
        }
      }
    }
  




